<?php


	@ini_set('display_errors', 1);
	@ini_set('display_startup_errors', 1);
	@error_reporting(E_ALL);


$sRootPath = dirname(__FILE__);

while((strlen($sRootPath) > 2) && !is_dir($sRootPath . '/idealcheckout'))
{
	$sRootPath = dirname($sRootPath);
}

if(!is_dir($sRootPath . '/idealcheckout'))
{
	die('Cannot find /idealcheckout/ folder.<br>File: ' . __FILE__ . '<br>Line: ' . __LINE__);
}

require_once($sRootPath . '/idealcheckout/includes/library.php');



class ControllerExtensionPaymentIdealcheckoutdirectebanking extends Controller
{
	public function index() 
	{
		$data['button_confirm'] = $this->language->get('button_confirm');

		$data['continue'] = $this->url->link('extension/payment/idealcheckoutdirectebanking/setup');

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/idealcheckoutdirectebanking.tpl')) 
		{
			return $this->load->view($this->config->get('config_template') . '/template/extension/payment/idealcheckoutdirectebanking', $data);
		}
		else
		{
			return $this->load->view('extension/payment/idealcheckoutdirectebanking', $data);
		}
	}

	public function confirm() 
	{
		//$this->load->model('checkout/order');
		//$this->model_checkout_order->confirm($this->session->data['order_id'], $this->config->get('idealcheckoutdirectebanking_order_status_id'));
	}

	public function getRootUrl()
	{
		$sRootUrl = ($this->config->get('config_secure') ? $this->config->get('config_ssl') : $this->config->get('config_url'));

		if(!is_string($sRootUrl) || (strlen($sRootUrl) < 10))
		{
			$sRootUrl = HTTPS_SERVER;
		}
		
		if(substr($sRootUrl, -1, 1) != '/')
		{
			$sRootUrl .= '/';
		}

		return $sRootUrl;
	}

	public function setup()
	{		
		$this->load->model('checkout/order');

		if(isset($this->session->data['order_id']))
		{
			$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
			
			$this->language->load('extension/payment/idealcheckoutdirectebanking');

			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			$aOrderParams = array();
			$aOrderParams['customer'] = array();


			$sShipmentCompany = '';
			$sShipmentFirstName = '';
			$sShipmentLastName = '';

			if(!empty($order_info['shipping_company']) && !empty($order_info['shipping_firstname']) && !empty($order_info['shipping_lastname']))
			{
				$sShipmentCompany = $order_info['shipping_company'];
				$sShipmentFirstName = $order_info['shipping_firstname'];
				$sShipmentLastName = $order_info['shipping_lastname'];
			}
			elseif(!empty($order_info['payment_company']) && !empty($order_info['payment_firstname']) && !empty($order_info['payment_lastname']))
			{
				$sShipmentCompany = $order_info['payment_company'];
				$sShipmentFirstName = $order_info['payment_firstname'];
				$sShipmentLastName = $order_info['payment_lastname'];
				
			}


			// Shipment data
			list($sStreetName, $sStreetNumber) = idealcheckout_splitAddress($order_info['shipping_address_1'] . ' ' . $order_info['shipping_address_2']);

			$aOrderParams['customer']['shipment_company'] = $sShipmentCompany;
			$aOrderParams['customer']['shipment_first_name'] = $sShipmentFirstName;
			$aOrderParams['customer']['shipment_last_name'] = $sShipmentLastName;
			$aOrderParams['customer']['shipment_gender'] = '';
			$aOrderParams['customer']['shipment_date_of_birth'] = '';
			$aOrderParams['customer']['shipment_phone'] = $order_info['telephone'];
			$aOrderParams['customer']['shipment_email'] = $order_info['email'];
			$aOrderParams['customer']['shipment_street_name'] = $sStreetName;
			$aOrderParams['customer']['shipment_street_number'] = $sStreetNumber;
			$aOrderParams['customer']['shipment_zipcode'] = $order_info['shipping_postcode'];
			$aOrderParams['customer']['shipment_city'] = $order_info['shipping_city'];
			$aOrderParams['customer']['shipment_country_code'] = $order_info['shipping_iso_code_2'];
			$aOrderParams['customer']['shipment_country_name'] = ((strcasecmp($order_info['shipping_iso_code_2'], 'BE') === 0) ? 'Belgie' : 'Nederland');


			// Payment data
			list($sStreetName, $sStreetNumber) = idealcheckout_splitAddress($order_info['payment_address_1'] . ' ' . $order_info['payment_address_2']);

			$aOrderParams['customer']['payment_company'] = $order_info['payment_company'];
			$aOrderParams['customer']['payment_first_name'] = $order_info['payment_firstname'];
			$aOrderParams['customer']['payment_last_name'] = $order_info['payment_lastname'];
			$aOrderParams['customer']['payment_gender'] = '';
			$aOrderParams['customer']['payment_date_of_birth'] = '';
			$aOrderParams['customer']['payment_phone'] = $order_info['telephone'];
			$aOrderParams['customer']['payment_email'] = $order_info['email'];
			$aOrderParams['customer']['payment_street_name'] = $sStreetName;
			$aOrderParams['customer']['payment_street_number'] = $sStreetNumber;
			$aOrderParams['customer']['payment_zipcode'] = $order_info['payment_postcode'];
			$aOrderParams['customer']['payment_city'] = $order_info['payment_city'];
			$aOrderParams['customer']['payment_country_code'] = $order_info['payment_iso_code_2'];
			$aOrderParams['customer']['payment_country_name'] = ((strcasecmp($order_info['payment_iso_code_2'], 'BE') === 0) ? 'Belgie' : 'Nederland');


			// Products
			$aOrderParams['products'] = array();
			$sCurrencyCode = $this->session->data['currency'];
			$aCartTotalExclForEachVat = array();
			$aCartTotalInclForEachVat = array();
			
			
			foreach($this->cart->getProducts() as $k => $aProduct)
			{
				$sDescription = $aProduct['name'];

				if(!empty($aProduct['model']))
				{
					$sDescription .= ' - ' . $aProduct['model'];
				}

				$fPriceExcl = round($this->currency->format($aProduct['price'], $sCurrencyCode, false, false), 2);
				$fPriceVat = round($this->tax->getTax($fPriceExcl, $aProduct['tax_class_id']), 2);

				if(($fPriceExcl < 0) || ($fPriceExcl > 0))
				{
					$fVatPercentage = round(($fPriceVat / $fPriceExcl) * 100, 0);
					$sVatPercentage = (($fVatPercentage < 10) ? '0' : '') . number_format($fVatPercentage * 1000, 0, '', '');
					$fPriceIncl = round($fPriceExcl + $fPriceVat, 2);

					if(!isset($aCartTotalExclForEachVat[$sVatPercentage]))
					{
						$aCartTotalExclForEachVat[$sVatPercentage] = 0.00;
						$aCartTotalInclForEachVat[$sVatPercentage] = 0.00;
					}
					
					$aCartTotalExclForEachVat[$sVatPercentage] += $fPriceExcl;
					$aCartTotalInclForEachVat[$sVatPercentage] += $fPriceIncl;

					$aOrderParams['products'][] = array('record_id' => $aProduct['product_id'], 'code' => $aProduct['product_id'], 'description' => $sDescription, 'quantity' => $aProduct['quantity'], 'price_incl' => $fPriceIncl, 'price_excl' => $fPriceExcl, 'vat' => $fVatPercentage, 'vat_amount' => $fPriceVat);
				}
			}		
			
			if(sizeof($aCartTotalExclForEachVat) > 1)
			{
				ksort($aCartTotalExclForEachVat);
				ksort($aCartTotalInclForEachVat);
			}
			
			$sql = "SELECT `code`, `value` FROM `" . $aDatabaseSettings['prefix'] . "order_total` WHERE (`order_id` = '" . idealcheckout_escapeSql($this->session->data['order_id']) . "')";
			$aResults = idealcheckout_database_getRecords($sql);
		
			$aOrderParams['totals'] = array();
			
			foreach($aResults as $aResult)
			{				
				$aOrderParams['totals'][$aResult['code']] = $aResult['value'];
			}

			// Discount?
			if(!empty($this->session->data['coupon']))
			{
				$this->load->model('checkout/coupon');
				$this->load->model('total/coupon');

				$total_data = array();
				$total = 0;
				$taxes = $this->cart->getTaxes();
		
				$sKey = key($taxes);

				if(empty($taxes[$sKey]))
				{
					$taxBefore = 0;
				}
				else
				{
					$taxBefore = $taxes[$sKey];
				}
				
				$this->model_total_coupon->getTotal($total_data, $total, $taxes);
				
				if(empty($taxes[$sKey]))
				{
					$taxAfter = 0;
				}
				else
				{
					$taxAfter = $taxes[$sKey];
				}
			
				$aCoupon = $this->model_checkout_coupon->getCoupon($this->session->data['coupon']);
				
				if(strcasecmp($aCoupon['type'], 'P') === 0)
				{
					foreach($aCartTotalExclForEachVat as $k => $v)
					{
						$fCouponDiscount = round((($v * floatval($aCoupon['discount'])) / 100), 2);
						$fCouponVatPercentage = intval($k) / 1000;
						$fCouponVatAmount =  round((($fCouponDiscount * $fCouponVatPercentage) / 100), 2);

						$aOrderParams['products'][] = array('record_id' => 0, 'code' => 'COUPON', 'description' => 'Coupon', 'quantity' => '1', 'price_incl' => -($fCouponDiscount + $fCouponVatAmount), 'price_excl' => -$fCouponDiscount, 'vat' => $fCouponVatPercentage, 'vat_amount' => -$fCouponVatAmount);
					}
				}
			}		
			

			// Voucher?
			if(isset($this->session->data['voucher']))
			{
				$this->load->model('checkout/voucher');
				$aVoucher = $this->model_checkout_voucher->getVoucher($this->session->data['voucher']);

				if(is_array($aVoucher) && !empty($aVoucher) && !empty($aVoucher['amount']))
				{
					$fDiscountAmount = -round($this->currency->format($aVoucher['amount'], $sCurrencyCode, false, false), 2);
					$fDiscountTaxAmount = 0;
					$fDiscountTaxPercentage = 0;

					if(($fDiscountAmount < 0) || ($fDiscountAmount > 0))
					{
						$aOrderParams['products'][] = array('record_id' => 0, 'code' => 'VOUCHER', 'description' => 'Voucher', 'quantity' => '1', 'price_incl' => $fDiscountAmount, 'price_excl' => $fDiscountAmount, 'vat' => $fDiscountTaxPercentage);
					}
				}
			}


			// Shipping costs?
			if(isset($this->session->data['shipping_method']['cost']) && ($this->session->data['shipping_method']['cost'] != 0))
			{
				$fShipmentAmount = round($this->currency->format($this->session->data['shipping_method']['cost'], $sCurrencyCode, false, false), 2);
				$fShipmentTaxAmount = round($this->tax->getTax($fShipmentAmount, $this->session->data['shipping_method']['tax_class_id']), 2);

				if(($fShipmentAmount < 0) || ($fShipmentAmount > 0))
				{
					$fShipmentTaxPercentage = round(($fShipmentTaxAmount / $fShipmentAmount) * 100, 0);
					$aOrderParams['products'][] = array('record_id' => 0, 'code' => 'SHIPPING', 'description' => 'Verzendkosten', 'quantity' => '1', 'price_incl' => ($fShipmentAmount + $fShipmentTaxAmount), 'price_excl' => $fShipmentAmount, 'vat' => $fShipmentTaxPercentage, 'vat_amount' => $fShipmentTaxAmount);
				}
			}


			// Payment costs?
			if(isset($this->session->data['payment_method']['cost']) && ($this->session->data['payment_method']['cost'] != 0))
			{
				$fPaymentAmount = round($this->currency->format($this->session->data['payment_method']['cost'], $sCurrencyCode, false, false), 2);
				$fPaymentTaxAmount = round($this->tax->getTax($fPaymentAmount, $this->session->data['payment_method']['tax_class_id']), 2);

				if(($fPaymentAmount < 0) || ($fPaymentAmount > 0))
				{
					$fPaymentTaxPercentage = round(($fPaymentTaxAmount / $fPaymentAmount) * 100, 0);
					$aOrderParams['products'][] = array('record_id' => 0, 'code' => 'PAYMENT', 'description' => 'Betaalkosten', 'quantity' => '1', 'price_incl' => ($fPaymentAmount + $fPaymentTaxAmount), 'price_excl' => $fPaymentAmount, 'vat' => $fPaymentTaxPercentage, 'vat_amount' => $fPaymentTaxAmount);
				}
			}


			$sStoreCode = idealcheckout_getStoreCode();
			$sGatewayCode = 'directebanking';
			$sLanguageCode = 'nl'; // nl, de, en
			$sCountryCode = '';
			$sCurrencyCode = 'EUR';

			$sOrderId = $this->session->data['order_id'];
			$sOrderCode = idealcheckout_getRandomCode(32);
			// $aOrderParams = array();
			$sTransactionId = idealcheckout_getRandomCode(32);
			$sTransactionCode = idealcheckout_getRandomCode(32);
			$fTransactionAmount = round($order_info['total'] * $order_info['currency_value'], 2);
			$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
			$sTransactionSuccessUrl = HTTPS_SERVER . 'index.php?route=extension/payment/idealcheckoutdirectebanking/callback'; //$this->url->link('payment/idealcheckoutdirectebanking/callback'); 
			$sTransactionSuccessUrl .= (strpos($sTransactionSuccessUrl, '?') ? '&' : '?') . 'order_id=' . $sOrderId . '&order_code=' . $sOrderCode;

			$sTransactionPendingUrl = $sTransactionSuccessUrl;
			$sTransactionFailureUrl = $sTransactionSuccessUrl;


			// Insert into #_transactions
			$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";
			idealcheckout_database_query($sql);

			// Set order to pending
			$iOrderPending = $this->config->get('payment_idealcheckoutdirectebanking_order_pending_status_id'); // 1;

			$this->model_checkout_order->addOrderHistory($sOrderId, $iOrderPending, "\n\n" . $this->language->get('text_payable') . "\n" . $this->language->get('text_title'), true);

			// Redirect to issuer_request.php
			$this->response->redirect($this->getRootUrl() . 'idealcheckout/setup.php?order_id=' . urlencode($sOrderId) . '&order_code=' . urlencode($sOrderCode));
		}
		else
		{
			idealcheckout_output('<code>Error while loading order data from session.</code>');
		}
	}

	public function callback() 
	{
		$this->load->model('checkout/order');
		$this->language->load('extension/payment/idealcheckoutdirectebanking');

		if(isset($_GET['order_id']) && preg_match('/[0-9]+/', $_GET['order_id']) && isset($_GET['order_code']) && preg_match('/[a-zA-Z0-9]{32,32}/', $_GET['order_code']))
		{
			$iOrderId = $_GET['order_id'];
			$sOrderCode = $_GET['order_code'];

			$iOrderPending = 1;
			$iOrderSuccess = 2;
			$iOrderFailure = 7;

			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			// Lookup transaction
			$sql = "SELECT `order_id`, `transaction_status`, `order_params` FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . idealcheckout_escapeSql($iOrderId) . "') AND (`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "') ORDER BY `id` DESC LIMIT 1;";
			$aRecord = idealcheckout_database_getRecord($sql);
			
			if($aRecord && ($oOrder = $this->model_checkout_order->getOrder($iOrderId)))
			{
				$this->session->data['order_id'] = $iOrderId;

				// Lookup last known order status
				$sql = "SELECT `order_status_id` AS `status` FROM `" . $aDatabaseSettings['prefix'] . "order` WHERE (`order_id` = '" . $aRecord['order_id'] . "') LIMIT 1;";
				$aOrder = idealcheckout_database_getRecord($sql);

				if(strcasecmp($aOrder['status'], '0') === 0) // NEW
				{
					if(strcasecmp($aRecord['transaction_status'], 'PENDING') === 0) // Set to PENDING
					{
						$this->model_checkout_order->addOrderHistory($aRecord['order_id'], $iOrderPending, "\n\n" . $this->language->get('text_payable') . "\n" . $this->language->get('text_title'), true);
						
						$this->response->redirect($this->url->link('checkout/success'));
					}
					elseif(strcasecmp($aRecord['transaction_status'], 'SUCCESS') === 0) // Set to SUCCESS
					{
						$this->model_checkout_order->addOrderHistory($aRecord['order_id'], $iOrderSuccess, "\n\n" . $this->language->get('text_payable') . "\n" . $this->language->get('text_title'), true);
						
						$this->response->redirect($this->url->link('checkout/success'));
					}
					else // Set to CANCELLED
					{
						// $this->model_checkout_order->update($aRecord['order_id'], $iOrderFailure, "\n\n" . $this->language->get('text_payable') . "\n" . $this->language->get('text_title'), true);
						// $this->returnStock($aRecord);

						$this->cancelOrder($aRecord['order_id'], false);
						$this->response->redirect($this->url->link('checkout/checkout'));
					}
				}
				elseif(strcasecmp($aOrder['status'], $iOrderPending) === 0) // PENDING
				{
					if(strcasecmp($aRecord['transaction_status'], 'PENDING') === 0) // Set to PENDING
					{
						$this->response->redirect($this->url->link('checkout/success'));
					}
					elseif(strcasecmp($aRecord['transaction_status'], 'SUCCESS') === 0) // Set to SUCCESS
					{
						$this->model_checkout_order->addOrderHistory($aRecord['order_id'], $iOrderSuccess, "\n\n" . $this->language->get('text_payable') . "\n" . $this->language->get('text_title'), true);
						
						$this->response->redirect($this->url->link('checkout/success'));
					}
					else // Set to CANCELLED
					{
						// $this->model_checkout_order->update($aRecord['order_id'], $iOrderFailure, "\n\n" . $this->language->get('text_payable') . "\n" . $this->language->get('text_title'), true);
						// $this->returnStock($aRecord);

						$this->cancelOrder($aRecord['order_id'], true);
						$this->response->redirect($this->url->link('checkout/checkout'));
					}
				}
				elseif(strcasecmp($aOrder['status'], $iOrderSuccess) === 0)
				{
					$this->response->redirect($this->url->link('checkout/success'));
				}
				elseif(strcasecmp($aOrder['status'], $iOrderFailure) === 0)
				{
					$this->response->redirect($this->url->link('checkout/checkout'));
				}
				else
				{
					$this->response->redirect($this->url->link('common/home'));
				}
			}
		}
		else
		{
			idealcheckout_output('<code>Error while loading order data from session.</code>');
		}
	}

	public function returnStock($aRecord)
	{
		$this->revertStock($aRecord['order_id']);
/*
		if(!empty($aRecord['order_params']))
		{
			$aOrderParams = idealcheckout_unserialize($aRecord['order_params']);

			if(isset($aOrderParams['products']) && is_array($aOrderParams['products']) && sizeof($aOrderParams['products']))
			{
				foreach($aOrderParams['products'] as $k => $v)
				{
					if(!empty($v['record_id']) && is_numeric($v['record_id']) && is_numeric($v['quantity']))
					{
						$sql = "UPDATE `" . DB_PREFIX . "product` SET `quantity` = (`quantity` + '" . $v['quantity'] . "') WHERE (`product_id` = '" . $v['record_id'] . "') AND (`subtract` = '1');";
						idealcheckout_database_query($sql);
					}
				}

				return true;
			}
		}

		return false;
*/
	}

	private function revertStock($order_id)
	{
		if(intval($order_id) <= 0)
		{
			return false;
		}

		$order_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order` WHERE `order_status_id` > '0' AND `order_id` = '" . (int)$order_id . "'");

		if($order_query->num_rows)
		{
			$order_product_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order_product` WHERE `order_id` = '" . (int)$order_id . "'");

			foreach($order_product_query->rows as $order_product)
			{
				$product_query = $this->db->query("SELECT `subtract` FROM `" . DB_PREFIX . "product` WHERE `product_id` = '" . (int)$order_product['product_id'] . "'");

				foreach($product_query->rows as $product)
				{
					if($product['subtract'])
					{
						$this->db->query("UPDATE `" . DB_PREFIX . "product` SET `quantity` = (`quantity` + " . (int)$order_product['quantity'] . ") WHERE `product_id` = '" . (int)$order_product['product_id'] . "'");

						$option_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order_option` WHERE `order_id` = '" . (int)$order_id . "' AND `order_product_id` = '" . (int)$order_product['order_product_id'] . "'");

						foreach($option_query->rows as $option)
						{
							$this->db->query("UPDATE `" . DB_PREFIX . "product_option_value` SET `quantity` = (`quantity` + " . (int)$order_product['quantity'] . ") WHERE `product_option_value_id` = '" . (int)$option['product_option_value_id'] . "' AND `subtract` = '1'");
						}
					}
				}
			}
		}
	}

	private function cancelOrder($iOrderId, $bReturnStock = false)
	{
		$iOrderCancel = $this->config->get('idealcheckoutideal_order_cancel_status_id');

		$this->db->query("UPDATE `" . DB_PREFIX . "order` SET `order_status_id` = '" . (int)$iOrderCancel . "', `date_modified` = NOW() WHERE order_id = '" . (int)$iOrderId . "'");
		$this->db->query("INSERT INTO `" . DB_PREFIX . "order_history` SET `order_id` = '" . (int)$iOrderId . "', `order_status_id` = '" . (int)$iOrderCancel . "', `notify` = '0', `comment` = 'Payment was cancelled.', `date_added` = NOW();");

		if($bReturnStock)
		{
			$this->revertStock($iOrderId);
		}
	}
}

?>